
#include <iostream>
using namespace std;


template <class T>
class Tree
{
   struct TreeNode 
   { 
      T value;
      TreeNode *left, *right;
      TreeNode() { left = right = nullptr; } 
   };

   TreeNode * root;

 public:
   Tree() { root = nullptr; }
  ~Tree() { /*   */ } 

   //    
   //    
   void Add (const T &x);     
   void Remove (const T &x);
   bool Search (const T &x);   

   template <class P>
   friend ostream & operator<<(ostream & os, const Tree<P> & tr);

 private:
   TreeNode * Search(TreeNode *r, const T &x) const;
   TreeNode * Add(TreeNode *r, const T &x);
   TreeNode * Remove(TreeNode *r, const T &x);
   void Print(ostream & os, const TreeNode *r) const;
};

//--------------------------------------------------------------

template<class T> 
typename Tree<T>::TreeNode * Tree<T>::Add(typename Tree<T>::TreeNode *r, const T &x)
{
    if (r == nullptr) {
        r = new typename Tree<T>::TreeNode;
        r->value = x;
    } else {  
        if (x > r->value) {
            r->right = Add(r->right, x);
        } else if (x < r->value) {
            r->left = Add(r->left, x);
        }
    }
    return r;
}

template<class T> 
void Tree<T>::Add(const T &x)
{
   root = Add(root, x);
}

//--------------------------------------------------------------

template<class T> 
void Tree<T>::Print(ostream & os, const TreeNode *r) const
{
    if (!r) return;
    os << r->value << endl;
    Print(os, r->left);
    Print(os, r->right);
}

template <class T>
ostream & operator<<(ostream & os, const Tree<T> & tr)
{
    os << "The tree:\n";
    tr.Print(os, tr.root);
    return os;
}

//--------------------------------------------------------------

template<class T> 
typename Tree<T>::TreeNode * Tree<T>::Search(typename Tree<T>::TreeNode *r, const T &x) const
{
   if (!r) return nullptr;
   if (x < r->value) { return Search(r->left, x); }
   else if (x > r->value) { return Search(r->right, x); }
   return r;
}

template<class T> 
bool  Tree<T>::Search (const T &x)
{
   return  (Search(root, x)) ? true : false;
}   
